/******************************************************************************
* Project:		morsix3330
* File:			init.h
* Date:			09.12.2007
* Author:		Philipp Burch
* E-Mail:		philipp_burch@gmx.ch
* Description:	Header file for init.c.
******************************************************************************/

#ifndef __INIT_H__
#define __INIT_H__


#include <stdint.h>


#define PIN_TEMP		PA7
#define RDD_TEMP_EN		DDRA
#define PIN_TEMP_EN		PA6
#define RPI_KEY_ROWS	PINA
#define PIN_KEY_R0		PA5
#define PIN_KEY_R1		PA4
#define PIN_KEY_R2		PA3
#define PIN_KEY_R3		PA2
#define RPO_KEY_C0		PORTA
#define PIN_KEY_C0		PA1
#define RPO_KEY_C1		PORTA
#define PIN_KEY_C1		PA0

#define RPO_AREF_UB		PORTB
#define PIN_AREF_UB		PB4
#define RPO_LIGHT		PORTB
#define PIN_LIGHT		PB3
#define RPI_ON_OFF		PINB
#define PIN_ON_OFF		PB2
#define RPO_KEY_C2		PORTB
#define PIN_KEY_C2		PB1
#define RPO_KEY_C3		PORTB
#define PIN_KEY_C3		PB0

#define RPO_DISP_DC		PORTC
#define PIN_DISP_DC		PC7
#define RPO_DISP_RES	PORTC
#define PIN_DISP_RES	PC6
#define RPO_DISP_CS		PORTC
#define PIN_DISP_CS		PC5
#define RDD_VOLUME		DDRC
#define PIN_VOL2		PC4
#define PIN_VOL1		PC3
#define PIN_VOL0		PC2
#define RPO_USB_EN		PORTC
#define PIN_USB_EN		PC1
#define RPO_SD_CS		PORTC
#define PIN_SD_CS		PC0

#define RPO_CHARGE		PORTD
#define PIN_CHARGE		PD7
#define RPO_VIB			PORTD
#define PIN_VIB			PD6
#define RDD_PHONE		DDRD
#define PIN_PHONE		PD5
#define RDD_SPEAKER		DDRD
#define PIN_SPEAKER		PD4
#define RDD_USB_DM		DDRD
#define RPO_USB_DM		PORTD
#define RPI_USB_DM		PIND
#define PIN_USB_DM		PD3
#define RDD_USB_DP		DDRD
#define RPO_USB_DP		PORTD
#define RPI_USB_DP		PIND
#define PIN_USB_DP		PD2


void init_ports();
void init_clock();
void init_spi();
void init_usart();
void init_sound();


#endif //__INIT_H__
