/******************************************************************************
* Project:		morsix3330
* File:			printf.h
* Date:			25.12.2007
* Author:		Philipp Burch
* E-Mail:		philipp_burch@gmx.ch
* Description:	Header file for printf.c.
******************************************************************************/

#ifndef __PRINTF_H__
#define __PRINTF_H__

#include <stdint.h>
#include <disp3330.h>

#define PRINTF_BUF_SIZE		64

typedef enum {
	USART = 1,
	DISPLAY = 2,
	SPEAKER = 4,
	PHONE = 8
} printf_target_t;

typedef enum {
	LEFT_JUSTIFY = 1,
	FORCE_SIGN = 2,
	USE_PADDING_SPACE = 4,
	USE_PREFIX = 8,
	USE_PADDING_ZERO = 16
} printf_flag_t;

void PrintF_Target(const printf_target_t);
void PrintF_Disp_Margins(const uint8_t, const uint8_t, const uint8_t, const uint8_t);
void PrintF_Disp_Locate(const uint8_t, const uint8_t);
void PrintF_Disp_Ctrl(const draw_mode_t, const bool, const bool, const bool);
int16_t PrintF(const char *, ...);

#endif //__PRINTF_H__

