/******************************************************************************
* Project:		morsix3330
* File:			main.c
* Date:			09.12.2007
* Author:		Philipp Burch
* E-Mail:		philipp_burch@gmx.ch
* Description:	This file contains the main code. Everything starts here.
******************************************************************************/

#include <main.h>
#include <stdint.h>
#include <init.h>
#include <avr/power.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <disp3330.h>
#include <util/delay.h>
#include <printf.h>
#include <debug.h>
#include <sound.h>


int main() {
	init_ports();
	init_clock();
	init_spi();
	init_usart();
	init_sound();

	sei();

	Disp_Init();

	RPO_LIGHT |= _BV(PIN_LIGHT);

	//Disp_Box(0, 0, 84, 48, COPY, true);
	/*point_t p;
	p = Disp_Print(5, 5, 70, 40, 10, 10, "morsix3330\n\nPh. Burch\nDEC 2007", XOR, false, true);
	Disp_Print(5, 5, 70, 40, p.x, p.y, "abc", XOR, false, true);*/
	/*Disp_Box(10, 10, 64, 28, COPY, true);
	point_t p = {10, 10};
	char s[] = " ";
	for (uint8_t i = 0; i < 26; ++i) {
		*s = 'a' + i;
		p = Disp_Print(10, 10, 64, 28, p.x, p.y, s, CLEAR, false, true);
	}*/
	//Disp_Line(60, 20, 80, 20, COPY);
	//Disp_Line(80, 20, 80, 40, COPY);
	//Disp_Line(0, 10, 5, 5, COPY);
//TCCR1B = _BV(CS11);
	/*Disp_Line(41, 23, 21, 23, COPY);
	Disp_Line(41, 23, 21, 33, COPY);
	Disp_Line(41, 23, 21, 43, COPY);
	Disp_Line(41, 23, 31, 43, COPY);
	Disp_Line(41, 23, 41, 43, COPY);
	Disp_Line(41, 23, 51, 43, COPY);
	Disp_Line(41, 23, 61, 43, COPY);
	Disp_Line(41, 23, 61, 33, COPY);
	Disp_Line(41, 23, 61, 23, COPY);
	Disp_Line(41, 23, 61, 13, COPY);
	Disp_Line(41, 23, 61, 3, COPY);
	Disp_Line(41, 23, 51, 3, COPY);
	Disp_Line(41, 23, 41, 3, COPY);*/
//	Disp_Line(41, 23, 31, 3, COPY);
	/*Disp_Line(41, 23, 21, 3, COPY);
	Disp_Line(41, 23, 21, 13, COPY);
	Disp_Line(41, 23, 21, 23, COPY);
	Disp_Line(41, 23, 21, 33, COPY);
	Disp_Line(41, 23, 21, 43, COPY);
	Disp_Line(41, 23, 31, 43, COPY);
	Disp_Line(41, 23, 41, 43, COPY);
	Disp_Line(41, 23, 51, 43, COPY);
	Disp_Line(41, 23, 51, 33, COPY);
	Disp_Line(41, 23, 51, 23, COPY);
	Disp_Line(41, 23, 51, 33, COPY);
	Disp_Line(41, 23, 51, 43, COPY);
	Disp_Line(41, 23, 41, 43, COPY);
	Disp_Line(41, 23, 31, 43, COPY);
	Disp_Line(41, 23, 21, 43, COPY);
	Disp_Line(41, 23, 21, 33, COPY);*/
//TCCR1B = 0;
	//Disp_Refresh();

	/*uint8_t x = 0, y = 0, a = 0;
	for (;;) {
		Disp_Clear_Cache();
		Disp_Line(41, 23, x, y, XOR);
		Disp_Refresh();
		if (a == 0) {
			++x;
			if (x > 83) {
				x = 83;
				a = 1;
			}
		} else if (a == 1) {
			++y;
			if (y > 47) {
				y = 47;
				a = 2;
			}
		} else if (a == 2) {
			--x;
			if (x == 0xff) {
				x = 0;
				a = 3;
			}
		} else {
			--y;
			if (y == 0xff) {
				y = 0;
				a = 0;
			}
		}
		for (uint8_t i = 0; i < 20; ++i) {
			_delay_ms(10);
		}
	}*/

	/*Disp_Line(40, 23, 39, 0, XOR);
	Disp_Line(41, 23, 41, 0, XOR);
	Disp_Refresh();*/

	debug_send_text("\nHello!\n");

	PrintF_Target(DISPLAY);
	//PrintF_Disp_Locate(10, 0);
	PrintF_Disp_Ctrl(COPY, true, true, true);

	/*PrintF("%+.8lf\n", -5962L);
	PrintF("%+i\n", -5962);
	PrintF("%+.11lf\n", 1234567890L);
	PrintF("%p\n", (void *)0xabcd);*/

	Sound_Control(PHONE_EN);

	uint8_t v = 0;
	for (;;) {
		Sound_Volume(v & 7);
		PrintF_Disp_Locate(0, 0);
		PrintF("Volume: %i", v & 7);
		for (uint8_t i = 0; i < 100; ++i) {
			_delay_ms(10);
		}
		++v;
	}

	debug_send_text("Good night!\n");


	for (;;) {
		__asm("nop");
	}
}


void sleep_well() {
	power_all_disable();
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);
	sleep_mode();
}

void wake_up() {
	power_all_enable();
}


