/******************************************************************************
* Project:		morsix3330
* File:			sound.c
* Date:			26.12.2007
* Author:		Philipp Burch
* E-Mail:		philipp_burch@gmx.ch
* Description:	This file contains any code needed to control the attached
*				speaker/phone.
******************************************************************************/

#include <sound.h>
#include <main.h>
#include <avr/io.h>
#include <stdint.h>
#include <init.h>


uint8_t Volume = 0;
sound_flag_t Flags = 0;


void Sound_Volume(const uint8_t vol) {
	if (vol > SOUND_MAX_VOLUME) {
		Volume = SOUND_MAX_VOLUME;
	} else {
		Volume = vol;
	}

	RDD_VOLUME = (RDD_VOLUME & ~PINS_VOL) | (Volume << PIN_VOL0);
}

void Sound_Control(const sound_flag_t flags) {
	Flags = flags;
	if (Flags & PHONE_EN) {
		RDD_PHONE |= _BV(PIN_PHONE);
	} else {
		RDD_PHONE &= ~_BV(PIN_PHONE);
	}
	if (Flags & SPEAKER_EN) {
		RDD_SPEAKER |= _BV(PIN_SPEAKER);
	} else {
		RDD_PHONE &= ~_BV(PIN_SPEAKER);
	}
}
